=== source/EXTENSIONS/BALLAXY/CMakeLists.txt ===
PROJECT(BALLAXY)

IF(NOT USE_QTWEBKIT)
	MESSAGE(STATUS "QtWebkit support has not been enabled. Disabling the BALLaxy plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/BALLaxyInterfacePreferences.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.C
	${DIRECTORY}/BALLaxyInterface.C
	${DIRECTORY}/BALLaxyInterfacePreferences.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/BALLaxyPlugin.h
	${DIRECTORY}/BALLaxyInterface.h
	${DIRECTORY}/BALLaxyInterfacePreferences.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginBALLaxy SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginBALLaxy PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginBALLaxy
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginBALLaxy BALL VIEW)
