=== source/EXTENSIONS/XML3D/CMakeLists.txt ===
PROJECT(XML3D)

IF(NOT BALL_HAS_VIEW)
	MESSAGE(STATUS "BALL is configured to not build the VIEW components. Disabling the XML3D plugin.")
	RETURN()
ENDIF()

IF(NOT BALL_PYTHON_SUPPORT)
	MESSAGE(STATUS "Python support has not been enabled. Disabling the XML3D plugin.")
	RETURN()
ENDIF()

FIND_PACKAGE(Loudmouth)
IF(NOT LIBLOUDMOUTH_FOUND)
	MESSAGE(STATUS "libloudmouth not found. Disabling the XML3D plugin.")
	RETURN()
ENDIF()
INCLUDE_DIRECTORIES(${LIBLOUDMOUTH_INCLUDE_DIR} ${LIBLOUDMOUTH_PKGCONF_INCLUDE_DIRS})

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
	${DIRECTORY}/XML3DSettings.ui
	${DIRECTORY}/XMPPWidget.ui
)

SET(SOURCES_LIST
	${DIRECTORY}/XML3DDriver.C
	${DIRECTORY}/XML3DPlugin.C
	${DIRECTORY}/XML3DSettings.C
	${DIRECTORY}/XMPPWidget.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/XML3DPlugin.h
	${DIRECTORY}/XML3DSettings.h
	${DIRECTORY}/XMPPWidget.h
)
#IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
#	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
#	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
#			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
#ENDIF()


QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginXML3D SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginXML3D PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginXML3D
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginXML3D BALL VIEW ${LIBLOUDMOUTH_LIBRARY})
