=== debian/changelog ===
ball (1.4.3~beta1-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Really ignore errors (one occures on build machine

 -- Andreas Tille <tille@debian.org>  Fri, 17 Mar 2017 15:16:42 +0100

ball (1.4.3~beta1-3) unstable; urgency=medium

  * Ignore test suite result on non-amd64
    Closes: #830984

 -- Danny Edel <debian@danny-edel.de>  Sun, 13 Nov 2016 18:24:33 +0100

ball (1.4.3~beta1-2) unstable; urgency=medium

  [ Danny Edel ]
  * Team upload
  * Fix FTBFS with GCC-6 and recent boost
    Closes: #830984, #833004
    * Patches backported from upstream git:
      * 2822068 Modify RTTI function isKindOf to take a pointer argument
        (this fixes a segfault in DefaultProcessors_test)
      * 0604808 Fix PoseClustering_test: replace serialized file comparison
      * 7380918 Fix XDRPersistenceManager_test
    * New patch: disable AmberFF_test, which fails nondeterministically
  * Drop previous PoseClustering_test patches (no longer needed)
  * d/watch: fix uversionmangle expression to correctly detect -BETA

  [ Andreas Tille ]
  * Remove useless Breaks in python-ballview and python-ball
  * lintian override for package-name-doesnt-match-sonames

 -- Danny Edel <debian@danny-edel.de>  Fri, 11 Nov 2016 12:07:51 +0100

ball (1.4.3~beta1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #777791
  * New homepage
  * Moved to Github
  * Adapt watch file to Github
  * Cherry-pick from upstream "Use c++11 on Clang"
  * Andreas Hildebrandt does not work on the packaging any more
  * cme fix dpkg-control
  * debian/rules: use dh
    Closes: #787888
  * debian/control: Drop *-dbg package since this is created automatically now
  * delete debian/menu
  * polish d/copyright
  * better hardening
  * cme fix dpkg-control
  * do not install empty directories for docs
  * do not repeat section field in d/control
  * doc package can be installed without main package -> only suggests main
    package
  * Use libjs-jquery instead of local copy pf jquery.js
  * DEP5 fixes
  * Use python-helper properly
  * Enhance long description of dev package
  * Use Breaks where Conflicts is to strong
  * Remove extra license file
  * Add lintian override for false positive package-contains-empty-directory

  [ Danny Edel ]
  * d/rules: Enable building and execution of unittests
  * Drop patch gcc5.diff (fixed upstream)
  * Backport patches from upstream git to fix FTBFS on recent sid:
    * b3679aa Fix: String failed to compile with newer GCC
    * 029fd2b Fix building PoseClustering with recent Boost
    * 3170b28 Fix compilation of BinaryFingerprintMethods_test
    * 7bb0166 Fixed PoseClustering test to account for changes in boost
    * 8ff1d1b FingerPrintSim: Fix build under clang 3.6 (also needed on gcc)
    * 38a955a Fix Python bindings for Box
    * f646875 Increased sleeping time on Socket_test
  * Add patches:
    * disable-assign-positions-from-template.patch
      (binary was only built, but not shipped previously, and fails to build
      with libeigen3-dev 3.3~beta1)
    * adjust-poseClustering_Test-boost-1.58.patch

 -- Andreas Tille <tille@debian.org>  Wed, 18 May 2016 14:49:09 +0200

ball (1.4.2+20140406-1.1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Non-maintainer upload.
  * Remove qt4-related non-development build dependencies (Closes: #787746).
  * Force linking against libX11 with link_against_x11.patch. It seems that
    now we require to manually explicit it.
  * Add findsip.patch by Dmitry Shachnev to fix sip library detection.

  [ Matthias Klose ]
  * Fix some build errors with GCC 5 and clang++. Closes: #755225.
    Addresses #777791.
  * Build using dh-python. Closes: #785941.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jul 2015 12:17:06 +0200
