=== debian/control ===
Source: ball
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-python,
               qt4-dev-tools,
               libqt4-dev,
               libqt4-opengl-dev,
               python-sip-dev,
               flex,
               bison,
               cmake,
               libqtwebkit-dev,
               libfftw3-dev,
               libeigen3-dev,
               libgsl0-dev,
               python-dev,
               libxrender-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-thread-dev,
               libboost-math-dev,
               libboost-system-dev,
               libasio-dev,
               libboost-regex-dev,
               libxmu-dev,
               libglew-dev,
               libx11-dev,
               tidy,
               chrpath,
               dh-python,
               libqt4-dev-bin
Build-Depends-Indep: doxygen,
                     graphviz,
                     ghostscript,
                     texlive-latex-base,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     texlive-latex-extra
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ball.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/ball.git
Homepage: http://www.ball-project.org/
X-Python-Version: all

Package: libball1.4-data
Architecture: all
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library (data files)
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libball1.4-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.4-dev
Architecture: any
Section: libdevel
Depends: libball1.4 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libball1.4-doc
Conflicts: libball1.3-dev
Description: Header files for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.4-dev
Architecture: any
Section: libdevel
Depends: libballview1.4 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libball1.4-doc
Conflicts: libballview1.3-dev
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package comprises the header files allowing to create one's own 
 applications with the VIEW framework of the BALL library.

Package: python-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python:Depends},
         ${sip:Depends},
         libball1.4,
         ${misc:Depends}
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-independent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: python-ballview
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python:Depends},
         ${sip:Depends},
         libball1.4,
         libballview1.4,
         python-ball (= ${binary:Version}),
         ${misc:Depends}
Description: Python bindings for VIEW-parts of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-dependent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Architecture: any
Depends: ${shlibs:Depends},
         libball1.4,
         libballview1.4,
         python-ball,
         python-ballview,
         ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures, 
 molecular mechanics methods (minimization, MD simulation using the 
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization 
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Suggests: libball1.4
Conflicts: libball1.3-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.
