=== debian/watch ===
version=3
opts=uversionmangle=s/_/./g;s/-BETA/~beta/ \
  https://github.com/BALL-Project/ball/releases .*/archive/V(\d[-\d._BETA]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
